DECLARE FUNCTION GetZOrder% (id%)
DECLARE SUB GetControl ()
DECLARE FUNCTION GetFreeWinVar% ()
DECLARE SUB Refresh ()
DECLARE SUB MkWindow (x%, y%, x2%, y2%, col%, title$, id%)
DECLARE SUB NewValidIf (num%)
DECLARE SUB RemoveValidIf (num%)
DECLARE FUNCTION RecentIf% ()
DECLARE SUB Parse.Variable (code$)
DECLARE FUNCTION GetFreeVar% ()
DECLARE SUB Parse.CreateWindow (code$)
DECLARE FUNCTION Parse.Line$ (line$)
DECLARE FUNCTION Parse.If$ (ifstatement$)
DECLARE FUNCTION Return.Variable.Value$ (variable$)
DECLARE FUNCTION IsComment% (pline$, word$)
DECLARE SUB Parse (file$)
DECLARE SUB MouseHide ()
DECLARE FUNCTION MouseLimit! (MiniX%, MiniY%, MaxiX%, MaxiY%)
DECLARE SUB MouseShow ()
DECLARE SUB mousedriver (ax%, bx%, cx%, dx%)
DECLARE FUNCTION mouseinit% ()
DECLARE SUB MouseStatus (lb%, rb%, xMouse%, yMouse%)
DECLARE SUB drawtextbox (x%, y%, length%, col%, text$)
DECLARE SUB drawcheckbox (x%, y%, checked%, colr%)
DECLARE SUB drawradio (x%, y%, checked%, colr%)
DECLARE SUB CloseWindow (id%)
'Flat GUI
DECLARE FUNCTION GetDragWindow% ()
DECLARE FUNCTION WindowInterfere% (id%)
DECLARE SUB MouseHide ()
DECLARE FUNCTION GetWindow% ()
DECLARE SUB GetControl ()
DECLARE SUB MakePrimaryZOrder (win%)
DECLARE FUNCTION MouseLimit! (MiniX%, MiniY%, MaxiX%, MaxiY%)
DECLARE SUB MouseShow ()
DECLARE SUB mousedriver (ax%, bx%, cx%, dx%)
DECLARE FUNCTION mouseinit% ()
DECLARE SUB MouseStatus (lb%, rb%, xMouse%, yMouse%)
'$INCLUDE: 'QB.BI'
DECLARE SUB MkRadioButton (x%, y%, checked%, col%, win%, id%)
DECLARE SUB MkTextBox (x%, y%, length%, col%, text$, win%, id%)
DECLARE SUB MkButton (x%, y%, caption$, col%, id%, win%)
DECLARE SUB Refresh ()
DECLARE SUB MkWindow (x%, y%, x2%, y2%, col%, title$, id%)
DECLARE SUB MakeNewZOrder (win%)
DECLARE FUNCTION GetLastZOrder% ()
DECLARE SUB drawtextbox (x%, y%, length%, col%, text$)
DECLARE SUB drawcheckbox (x%, y%, checked%, colr%)
DECLARE SUB drawradio (x%, y%, checked%, colr%)
DECLARE SUB drawwindow (x%, y%, x2%, y2%, caption$, col%)
DECLARE SUB drawtext (a$, x%, y%, Co%, Bkgd%, Shadow%)
DECLARE SUB drawbutton (x%, y%, caption$, col%)
TYPE Radio
  x AS INTEGER
  y AS INTEGER
  col AS INTEGER
  checked AS INTEGER
  win AS INTEGER
END TYPE
TYPE Checkbox
  x AS INTEGER
  y AS INTEGER
  col AS INTEGER
  checked AS INTEGER
  win AS INTEGER
END TYPE
TYPE Button
  x AS INTEGER
  y AS INTEGER
  col AS INTEGER
  win AS INTEGER
END TYPE
TYPE WindowType      'LA VENTANA TIENE "z" PARA LA ORDER DE "Z"
  x AS INTEGER
  y AS INTEGER
  x2 AS INTEGER
  y2 AS INTEGER
  col AS INTEGER
  z AS INTEGER       'DEPRECATE?
END TYPE
TYPE Label
  x AS INTEGER
  y AS INTEGER
  col AS INTEGER
  win AS INTEGER
END TYPE
TYPE Textbox
  x AS INTEGER
  y AS INTEGER
  length AS INTEGER
  col AS INTEGER
  win AS INTEGER
END TYPE
DIM SHARED Buttons(30) AS Button
DIM SHARED Windows(20)   AS WindowType
DIM SHARED ZOrder(20) AS INTEGER
DIM SHARED RadioButtons(30) AS Radio
DIM SHARED CheckBoxes(30) AS Checkbox
DIM SHARED ButtonCaptions(30) AS STRING
DIM SHARED WindowCaptions(20)   AS STRING   '20 VENTANAS, PERO 30 CONTROLS?
DIM SHARED Labels(30) AS Label
DIM SHARED LabelTexts(30) AS STRING
DIM SHARED TextBoxes(30) AS Textbox
DIM SHARED TextBoxTexts(30) AS STRING
DIM SHARED ButtonInvert(5000)
DIM SHARED MOUSE$
DIM SHARED var(200) AS STRING
DIM SHARED varstr(200) AS STRING
DIM SHARED validif(100) AS INTEGER
DIM SHARED First.Run%, Search.For.If%
First.Run% = 0  'THIS VARIABLE TELLS THE PARSER TO READ A FILE AND JUST LOAD IT INTO MEMORY
Search.For.If% = 0  'THIS VARIABLE TELLS THE PARSER TO LOOK FOR AN IF STATEMENT
MOUSE$ = SPACE$(57)
DATA 55,89,E5,8B,5E,0C,8B,07,50,8B,5E,0A,8B,07,50,8B
DATA 5E,08,8B,0F,8B,5E,06,8B,17,5B,58,1E,07,CD,33,53
DATA 8B,5E,0C,89,07,58,8B,5E,0A,89,07,8B,5E,08,89,0F
DATA 8B,5E,06,89,17,5D,CA,08,00

FOR I% = 1 TO 57
        READ a$
        H$ = CHR$(VAL("&H" + a$))
        MID$(MOUSE$, I%, 1) = H$
NEXT I%

SCREEN 12
MouseShow
First.Run% = 1

'Parse.Variable "var winvar as 10"

Parse "C:\QB45\SCR2.TXT"
Refresh
DO
  GetControl
LOOP UNTIL INKEY$ = CHR$(27)

SUB CloseWindow (id%)
FOR z = 1 TO 20
  IF ZOrder(z) = id% THEN aa% = z: EXIT FOR
NEXT z
ZOrder(aa%) = 0  'Termina de la memoria
IF aa% < 20 THEN  'Si no esta 20, el maximo
FOR ab = aa% TO 20
  IF ab < 20 THEN SWAP ZOrder(ab), ZOrder(ab + 1)
NEXT ab
END IF
END SUB

SUB drawbutton (x%, y%, caption$, col%)
x2% = x% + 8 + (LEN(caption$) * 8)
y2% = y% + 12
LINE (x%, y%)-(x2%, y2%), col%, BF
LINE (x%, y%)-(x2%, y2%), 0, B
txtcol% = 0
IF col% = 0 OR col% = 1 THEN txtcol% = 15
drawtext caption$, x% + 4, y% + 3, txtcol%, 7, 0
END SUB

SUB drawcheckbox (x%, y%, checked%, colr%)

LINE (x%, y%)-(x% + 14, y% + 14), colr%, BF
LINE (x%, y%)-(x% + 14, y% + 14), 0, B
IF checked% = 1 THEN
LINE (x%, y%)-(x% + 14, y% + 14), 0
LINE (x% + 14, y%)-(x%, y% + 14), 0
END IF
END SUB

SUB drawradio (x%, y%, checked%, colr%)
LINE (x%, y%)-(x% + 12, y% + 12), colr%, BF
CIRCLE (x% + 6, y% + 6), 6, 0
IF checked% = 1 THEN
  LINE (x% + 3, y% + 3)-(x% + 9, y% + 9), 0, BF
END IF
END SUB

SUB drawtext (a$, x%, y%, Co%, Bkgd%, Shadow%)
DEFINT A-Z
extX% = 8: extY% = 0
DEF SEG = &HFFA6
 FOR I% = 1 TO LEN(a$)
    ADDR% = 8 * ASC(MID$(a$, I%)) + 14
    IF Background% THEN
    IF Background% = 256 THEN BG% = false ELSE BG% = Bkgd%
    IF I% = LEN(a$) THEN extX% = false: extY% = false
    LINE (x%, y%)-(x% + 7 + extX%, y% + 7 + extY%), BG%, BF
    END IF
    FOR j% = 0 TO 7: mask% = PEEK(ADDR% + j%) * 128
    IF Shadow% THEN
    IF Shadow% > 1 THEN
    LINE (x% + 9, y% + j% + 2)-(x% + 1, y% + j% + 1), Shadow%, , mask%
    ELSE
    LINE (x% + 9, y% + j% + 2)-(x% + 2, y% + j% + 2), 0, , mask%
    END IF
    END IF
    LINE (x% + 7, y% + j%)-(x%, y% + j%), Co%, , mask%
    NEXT: x% = x% + extX%: y% = y% + extY%:  NEXT: DEF SEG
END SUB

DEFSNG A-Z
SUB drawtextbox (x%, y%, length%, col%, text$)
LINE (x%, y%)-(x% + 8 + (length% * 8), y% + 12), col%, BF
LINE (x%, y%)-(x% + 8 + (length% * 8), y% + 12), 0, B
printtxt$ = text$
IF LEN(text$) > length% THEN printtxt$ = LEFT$(text$, length%)
txtcol% = 0
IF col% = 0 OR col% = 1 THEN txtcol% = 15
drawtext printtxt$, x% + 4, y% + 3, txtcol%, 0, 0
END SUB

SUB drawwindow (x%, y%, x2%, y2%, caption$, col%)
LINE (x%, y%)-(x2%, y2%), col%, BF
LINE (x%, y%)-(x2%, y2%), 0, B
LINE (x%, y%)-(x2%, y% + 12), 0, B
LINE (x2% - 20, y% + 2)-(x2% - 12, y% + 10), 0, B
LINE (x2% - 18, y% + 7)-(x2% - 14, y% + 8), 0, BF
LINE (x2% - 10, y% + 2)-(x2% - 2, y% + 10), 0, B
LINE (x2% - 9, y% + 3)-(x2% - 3, y% + 9), 0
LINE (x2% - 3, y% + 3)-(x2% - 9, y% + 9), 0

drawtext caption$, x% + 6, y% + 3, 0, 7, 0
END SUB

SUB GetControl
  MouseStatus lb%, rb%, x%, y%
  IF lb% = -1 THEN
  candrag% = 0
  DO
      MouseStatus lb%, rb%, x%, y%
      
        z% = GetWindow%
        FOR B = 1 TO 30
        IF (Buttons(B).win = z% AND ButtonCaptions(B) <> "") THEN
          bx% = Buttons(B).x
          by% = Buttons(B).y
          
          IF MouseLimit(Windows(ZOrder(z%)).x + bx%, Windows(ZOrder(z%)).y + by%, 8 + (LEN(ButtonCaptions(B)) * 8), 12) = -1 THEN
           
           MouseHide
           GET (Windows(ZOrder(z%)).x + bx%, Windows(ZOrder(z%)).y + by%)-(Windows(ZOrder(z%)).x + bx% + 8 + (LEN(ButtonCaptions(B)) * 8), Windows(ZOrder(z%)).y + by% + 12), ButtonInvert
           PUT (Windows(ZOrder(z%)).x + bx%, Windows(ZOrder(z%)).y + by%), ButtonInvert, PRESET
           MouseShow
           DO
             MouseStatus mlb%, rb%, x%, y%
           LOOP UNTIL mlb% = 0
           MouseHide
           PUT (Windows(ZOrder(z%)).x + bx%, Windows(ZOrder(z%)).y + by%), ButtonInvert, PSET
           MouseShow
          END IF
        END IF
        NEXT B
        a% = GetWindow%
        wx% = Windows(a%).x
        wy% = Windows(a%).y
        wid% = Windows(a%).x2 - wx%
        hei% = Windows(a%).y2 - wy%
        
        IF MouseLimit(wx% + wid% - 10, wy% + 2, 8, 8) = -1 THEN  'CloseButton
        IF z% > 0 THEN
        IF (ZOrder(1) <> 0 AND ZOrder(2) = 0) THEN clse% = -1
        CloseWindow z%
        IF clse% = -1 THEN SYSTEM
        END IF
        Refresh
        END IF
        IF MouseLimit(wx% + wid% - 20, wy% + 2, 8, 8) = -1 THEN 'MinimizeButton
        PRINT "MINIMIZE"
        END IF
      IF (WindowInterfere%(ZOrder(z%)) = 0 OR ZOrder(GetDragWindow%) = 1) THEN candrag% = GetDragWindow%
      IF candrag% <> 0 THEN
        wx% = Windows(ZOrder(candrag%)).x
        wy% = Windows(ZOrder(candrag%)).y
        wid% = Windows(ZOrder(candrag%)).x2 - wx%
        hei% = Windows(ZOrder(candrag%)).y2 - wy%
        fromx% = x% - wx%: fromy% = y% - wy%
        
        DO
          MouseStatus mlb%, rb%, mx%, my%
          LINE (mx% - fromx%, my% - fromy%)-(mx% - fromx% + wid%, my% - fromy% + hei%), 15, B
        LOOP UNTIL mlb% = 0
        Windows(ZOrder(candrag%)).x = mx% - fromx%
        Windows(ZOrder(candrag%)).y = my% - fromy%
        Windows(ZOrder(candrag%)).x2 = mx% - fromx% + wid%
        Windows(ZOrder(candrag%)).y2 = my% - fromy% + hei%
        'IF ZOrder(2) <> 0 THEN MakePrimaryZOrder candrag%
        MakePrimaryZOrder candrag%
        Refresh
      END IF
      IF (GetWindow% <> 0 AND GetWindow% <> ZOrder(1)) THEN
        MakePrimaryZOrder GetWindow%
        Refresh
        EXIT SUB
      END IF
      'Refresh 'DEPRECATE
     
    LOOP UNTIL lb% = 0
  END IF
END SUB

FUNCTION GetDragWindow%
FOR w = 20 TO 1 STEP -1
wx% = Windows(ZOrder(w)).x: wy% = Windows(ZOrder(w)).y
wid% = Windows(ZOrder(w)).x2 - wx%
IF MouseLimit(wx%, wy%, wid% - 21, 12) = -1 THEN
 GetDragWindow% = w
END IF
NEXT w
END FUNCTION

FUNCTION GetFreeVar%
FOR I = 1 TO 200
  IF var(I) = "" THEN GetFreeVar% = INT(I): EXIT FUNCTION
NEXT I
END FUNCTION

FUNCTION GetFreeWinVar%
FOR I = 1 TO 20
  IF WindowCaptions(I) = "" THEN GetFreeWinVar% = INT(I): EXIT FOR
NEXT I
END FUNCTION

FUNCTION GetLastZOrder%
GetLastZOrder% = 0
FOR z = 1 TO 20
 IF WindowCaptions(ZOrder(z)) <> "" THEN GetLastZOrder% = z: EXIT FUNCTION
NEXT z
END FUNCTION

FUNCTION GetWindow%
FOR wi = 20 TO 1 STEP -1
  wid% = Windows(ZOrder(wi)).x2 - Windows(ZOrder(wi)).x
  hei% = Windows(ZOrder(wi)).y2 - Windows(ZOrder(wi)).y
  IF MouseLimit(Windows(ZOrder(wi)).x, Windows(ZOrder(wi)).y, wid%, hei%) = -1 THEN
     GetWindow% = ZOrder(wi)
  END IF
NEXT wi
END FUNCTION

FUNCTION GetZOrder% (id%)
FOR z = 1 TO 20
  IF ZOrder(z) = id% THEN GetZOrder% = z: EXIT FUNCTION
NEXT z
END FUNCTION

FUNCTION IsComment% (pline$, word$)
cmt% = INSTR(pline$, "//")
lin% = INSTR(UCASE$(pline$), UCASE$(word$))
IF ((cmt% <> 0 OR (cmt% < lin%)) OR LEFT$(pline$, 2) = "//") THEN IsComment% = 1
END FUNCTION

SUB MakeNewZOrder (win%)
ZOrder(win%) = win%
FOR z = 1 TO 20
IF ZOrder(z) = 0 THEN EXIT FOR
IF ZOrder(z + 1) = 0 THEN EXIT FOR
  SWAP ZOrder(z), ZOrder(z + 1)
NEXT z
END SUB

SUB MakePrimaryZOrder (win%)
FOR za = 1 TO 20
  IF ZOrder(za) = win% THEN last% = za: EXIT FOR
NEXT za

'FOR z = last% TO 1 STEP -1
'  SWAP ZOrder(z), ZOrder(z + 1)
'NEXT z
'a% = ZOrder(1)
'b% = ZOrder(last%)
'ZOrder(1) = b%
'ZOrder(last%) = a%
SWAP ZOrder(1), ZOrder(last%)

END SUB

SUB MkButton (x%, y%, caption$, col%, id%, win%)
Buttons(id%).x = x%
Buttons(id%).y = y%
Buttons(id%).col = col%
ButtonCaptions(id%) = caption$
Buttons(id%).win = win%
END SUB

SUB MkCheckBox (x%, y%, checked%, col%, win%, id%)
CheckBoxes(id%).x = x%
CheckBoxes(id%).y = y%
CheckBoxes(id%).checked = checked%
CheckBoxes(id%).col = col%
CheckBoxes(id%).win = win%
END SUB

SUB MkLabel (x%, y%, text$, col%, win%, id%)
Labels(id%).x = x%
Labels(id%).y = y%
Labels(id%).col = col%
LabelTexts(id%) = text$
Labels(id%).win = win%
END SUB

SUB MkRadioButton (x%, y%, checked%, col%, win%, id%)
RadioButtons(id%).x = x%
RadioButtons(id%).y = y%
RadioButtons(id%).checked = checked%
RadioButtons(id%).col = col%
RadioButtons(id%).win = win%

END SUB

SUB MkTextBox (x%, y%, length%, col%, text$, win%, id%)
TextBoxes(id%).x = x%
TextBoxes(id%).y = y%
TextBoxes(id%).length = length%
TextBoxes(id%).col = col%
TextBoxes(id%).win = win%
TextBoxTexts(id%) = text$
END SUB

SUB MkWindow (x%, y%, x2%, y2%, col%, title$, id%)
Windows(id%).x = x%
Windows(id%).y = y%
Windows(id%).x2 = x2%
Windows(id%).y2 = y2%
WindowCaptions(id%) = title$
Windows(id%).col = col%
MakeNewZOrder id%
END SUB

SUB mousedriver (ax%, bx%, cx%, dx%)
  DEF SEG = VARSEG(MOUSE$)
  MOUSE% = SADD(MOUSE$)
  CALL ABSOLUTE(ax%, bx%, cx%, dx%, MOUSE%)
END SUB

SUB MouseHide
mousedriver 2, 0, 0, 0
END SUB

FUNCTION mouseinit%
mousedriver 0, 0, 0, 0
mouseinit% = ax%
END FUNCTION

FUNCTION MouseLimit (MiniX%, MiniY%, MaxiX%, MaxiY%)
MouseLimit = 0
CALL MouseStatus(LeftButton%, RightButton%, xMouse%, yMouse%)

IF xMouse% >= MiniX% AND xMouse% <= MiniX% + MaxiX% THEN
   IF yMouse% >= MiniY% AND yMouse% <= MiniY% + MaxiY% THEN
        MouseLimit = -1
   END IF
END IF
END FUNCTION

SUB MousePut (x%, y%)
mousedriver 4, 0, x%, y%
END SUB

SUB MouseRange (x1%, y1%, x2%, y2%)
mousedriver 7, 0, x1%, x2%
mousedriver 8, 0, y1%, y2%
END SUB

SUB MouseShow
mousedriver 1, 0, 0, 0
END SUB

SUB MouseStatus (lb%, rb%, xMouse%, yMouse%)
mousedriver 3, bx%, cx%, dx%
lb% = ((bx% AND 1) <> 0)
rb% = ((bx% AND 2) <> 0)
xMouse% = cx%
yMouse% = dx%
END SUB

SUB NewDirsandFiles (path$)
'Return the files and directories in a path

'Parse for a trailing backslash
IF RIGHT$(path$, 1) = "\" THEN ppath$ = path$
IF RIGHT$(path$, 1) <> "\" THEN ppath$ = path$ + "\"
SHELL "DIR /AD /B " + ppath$ + "*.* >TEMP1.DAT"

SHELL "DIR /A-D /B " + ppath$ + "*.* >TEMP2.DAT"
END SUB

SUB NewValidIf (num%)
validif(num%) = num%
END SUB

SUB Parse (file$)
f = FREEFILE
Brackets.Start% = 0
Brackets.End% = 0
Program.Loop% = 0
ifcontinue% = 0
Look.For.Endif% = 0
Execute.If% = 0
Previous.If% = 0
OPEN file$ FOR INPUT AS #f
DO
  'LOCATE 1, 1: PRINT ifcontinue%
  LINE INPUT #f, pline$
  IF (pline$ <> "" AND ifcontinue% = 0) OR (Execute.If% = -1 AND ifcontinue% = -1) THEN
    IF Parse.Line$(pline$) = "START" THEN
      IF ifcontinue% = 0 THEN
        Brackets.Start% = Brackets.Start% + 1
        IF Previous.If% = -1 THEN Previous.If% = 0
        IF Previous.If% = 0 THEN Program.Loop% = -1
        IF Previous.If% = -1 THEN Look.For.Endif% = -1: NewValidIf Brackets.Start%
      END IF
      IF ifcontinue% = -1 THEN
        Brackets.Start% = Brackets.Start% + 1
        Execute.If% = -1
        Look.For.Endif% = -1
        NewValidIf Brackets.Start%
      END IF
    END IF
    IF Parse.Line$(pline$) = "END" THEN
      IF ifcontinue% = 0 THEN
        IF Previous.If% = 0 THEN Program.Loop% = 0
        IF Previous.If% = -1 THEN
        Previous.If% = 0
        Look.For.Endif% = 0:
        Execute.If% = 0:
        RemoveValidIf Brackets.Start%
        IF RecentIf% > 0 THEN Execute.If% = -1: Look.For.Endif% = -1
        END IF
        Brackets.Start% = Brackets.Start% - 1
      END IF
      IF ifcontinue% = -1 THEN
        ifcontinue% = 0
        RemoveValidIf Brackets.Start%
        Brackets.Start% = Brackets.Start% - 1
        Look.For.Endif% = 0
        Execute.If% = 0
        IF RecentIf% > 0 THEN Execute.If% = -1: Look.For.Endif% = -1
      END IF
    END IF
    IF Parse.Line$(pline$) = "VAR" THEN
      Parse.Variable pline$
    END IF
    IF (Parse.Line$(pline$) = "CREATE.WINDOW" AND ifcontinue% = 0 AND Previous.If% = 0) OR (Parse.Line$(pline$) = "CREATE.WINDOW" AND Previous.If% = -1 AND Execute.If% = -1) THEN
      Parse.CreateWindow pline$
    END IF
    IF Parse.Line$(pline$) = "IF" THEN
      a$ = Parse.If$(pline$)
      ' Say a$ is "x = 15", what to do?
      B% = INSTR(a$, "=")
      c% = INSTR(a$, "<")
      d% = INSTR(a$, ">")
      e% = INSTR(a$, "<>")
      f% = INSTR(a$, "<=")
      g% = INSTR(a$, ">=")
      Previous.If% = -1
      IF B% = 0 AND c% = 0 AND d% = 0 AND e% = 0 AND f% = 0 AND g% = 0 THEN
        Error.Type$ = "IF STATEMENT HAS NO QUERIE OR OPERATOR!"
      END IF
      IF B% <> 0 THEN  ' x = y
        var$ = LEFT$(a$, B% - 1)
        value$ = RIGHT$(a$, LEN(a$) - B% - 1)
        IF Return.Variable.Value$(var$) = value$ THEN  'if the variable equals a value then
          ifcontinue% = -1
          Execute.If% = -1
          Look.For.Endif% = -1
          ' IT IS EQUAL
        ELSE
          ifcontinue% = 0
          Execute.If% = 0
          ' IT ISN'T EQUAL
        END IF
      END IF
      IF c% <> 0 AND (e% <> c% AND f% <> c%) THEN  ' <
        var$ = LEFT$(a$, c% - 1)
        value$ = RIGHT$(a$, LEN(a$) - c%)
        IF Return.Variable.Value$(var$) < value$ THEN
          ifcontinue% = -1
        ELSE
          ifcontinue% = 0
        END IF
      END IF
      IF d% <> 0 AND (d% <> e% AND d% <> g%) THEN  ' >
        var$ = LEFT$(a$, d% - 1)
        value$ = RIGHT$(a$, LEN(a$) - d%)
        IF Return.Variable.Value$(var$) > value$ THEN
          ifcontinue% = -1
        ELSE
          ifcontinue% = 0
        END IF
      END IF
      IF e% <> 0 THEN  ' <>
        var$ = LEFT$(a$, e% - 1)
        value$ = RIGHT$(a$, LEN(a$) - e%)
        IF Return.Variable.Value$(var$) <> value$ THEN
          ifcontinue% = -1
        ELSE
          ifcontinue% = 0
        END IF
      END IF
      IF f% <> 0 THEN  ' <=
        var$ = LEFT$(a$, f% - 1)
        value$ = RIGHT$(a$, LEN(a$) - f%)
        IF Return.Variable.Value$(var$) <= value$ THEN
          ifcontinue% = -1
        ELSE
          ifcontinue% = 0
        END IF
      END IF
      IF g% <> 0 THEN  ' >=
        var$ = LEFT$(a$, g% - 1)
        value$ = RIGHT$(a$, LEN(a$) - g%)
        IF Return.Variable.Value$(var$) >= value$ THEN
          ifcontinue% = -1
        ELSE
          ifcontinue% = 0
        END IF

      END IF


    END IF
  END IF
LOOP UNTIL EOF(f)
CLOSE #f
END SUB

SUB Parse.CreateWindow (code$)
a% = INSTR(UCASE$(code$), "CREATE.WINDOW")
' Set A to be the starting position of the line
' [e.g]
' create.window ....
'                             create.window ....
start% = a% + 14
B% = INSTR(a%, code$, ",")   ' x
c% = INSTR(B% + 1, code$, ",")  ' y
d% = INSTR(c% + 1, code$, ",")  ' x2
e% = INSTR(d% + 1, code$, ",")  ' y2
f% = INSTR(e% + 1, code$, "'")  ' text
g% = INSTR(f% + 1, code$, "'")  ' end text
H% = INSTR(g% + 1, code$, ",")  ' variable

aa$ = MID$(code$, a% + 14, B% - (a% + 14))
ab$ = MID$(code$, B% + 1, c% - B% - 1)
ac$ = MID$(code$, c% + 1, d% - c% - 1)
ad$ = MID$(code$, d% + 1, e% - d% - 1)
ae$ = MID$(code$, e% + 1, f% - e% - 1)
af$ = MID$(code$, f% + 1, g% - f% - 1)
ag$ = MID$(code$, g% + 1, H% - g% - 1)
ah$ = MID$(code$, H% + 1 + 1, LEN(code$) - H% - 1)
IF UCASE$(ah$) = "NEWWIN" THEN id% = GetFreeWinVar%
IF UCASE$(ah$) <> "NEWWIN" THEN id% = INT(VAL(ah$))

MkWindow INT(VAL(aa$)), INT(VAL(ab$)), INT(VAL(ac$)), INT(VAL(ad$)), 11, af$, id%
END SUB

FUNCTION Parse.If$ (ifstatement$)
a% = INSTR(UCASE$(ifstatement$), "IF")
IF a% <> 0 THEN
  B% = a% + 3
  c% = LEN(ifstatement$) - a%
  length% = c% - 7
  Parse.If$ = MID$(ifstatement$, B%, length%)
END IF
END FUNCTION

FUNCTION Parse.Line$ (line$)
a% = INSTR(UCASE$(line$), "//")
B% = INSTR(UCASE$(line$), "{")
c% = INSTR(UCASE$(line$), "VAR")
d% = INSTR(UCASE$(line$), "IF")
e% = INSTR(UCASE$(line$), "}")
f% = INSTR(UCASE$(line$), "CREATE.WINDOW")
g% = INSTR(UCASE$(line$), "CREATE.BUTTON")
FOR I = 1 TO 200
  IF I = a% THEN linvar$ = "A": EXIT FOR
  IF I = B% THEN linvar$ = "B": EXIT FOR
  IF I = c% THEN linvar$ = "C": EXIT FOR
  IF I = d% THEN linvar$ = "D": EXIT FOR
  IF I = e% THEN linvar$ = "E": EXIT FOR
  IF I = f% THEN linvar$ = "F": EXIT FOR
  IF I = g% THEN linvar$ = "G": EXIT FOR
NEXT I
IF a% >= 1 AND linvar$ = "A" THEN Parse.Line$ = "COMMENT"
IF B% >= 1 AND linvar$ = "B" THEN
  Parse.Line$ = "START"
  
END IF
IF c% >= 1 AND linvar$ = "C" THEN
  Parse.Line$ = "VAR"
  
END IF
IF d% >= 1 AND linvar$ = "D" THEN
  Parse.Line$ = "IF"
  
END IF
IF e% >= 1 AND linvar$ = "E" THEN
  Parse.Line$ = "END"
  
END IF
IF f% >= 1 AND linvar$ = "F" THEN
  Parse.Line$ = "CREATE.WINDOW"
  
END IF
IF g% >= 1 AND linvar$ = "G" THEN
  Parse.Line$ = "CREATE.BUTTON"
END IF
END FUNCTION

SUB Parse.Variable (code$)
a% = INSTR(1, UCASE$(code$), "VAR")
B% = INSTR(1, UCASE$(code$), "AS")
var$ = MID$(code$, a% + 4, (B% - a% - 4))
value$ = MID$(code$, B% + 3, LEN(code$) - B% - 2)
c% = GetFreeVar%
var(c%) = var$
varstr(c%) = value$
END SUB

FUNCTION RecentIf%
FOR I = 1 TO 100
  IF validif(I) = 0 THEN RecentIf% = INT(I) - 1: EXIT FUNCTION
NEXT I
END FUNCTION

SUB Refresh
MouseHide
FOR w = 20 TO 1 STEP -1
  drawwindow Windows(ZOrder(w)).x, Windows(ZOrder(w)).y, Windows(ZOrder(w)).x2, Windows(ZOrder(w)).y2, WindowCaptions(ZOrder(w)), Windows(ZOrder(w)).col
  IF w = 1 THEN
  wx% = Windows(ZOrder(w)).x: wy% = Windows(ZOrder(w)).y
  FOR c = 1 TO 30
    IF RadioButtons(c).win = ZOrder(1) THEN drawradio wx% + RadioButtons(c).x, wy% + RadioButtons(c).y, RadioButtons(c).checked, RadioButtons(c).col
    IF CheckBoxes(c).win = ZOrder(1) THEN drawcheckbox wx% + CheckBoxes(c).x, wy% + CheckBoxes(c).y, CheckBoxes(c).checked, CheckBoxes(c).col
    IF Buttons(c).win = ZOrder(1) THEN drawbutton wx% + Buttons(c).x, wy% + Buttons(c).y, ButtonCaptions(c), Buttons(c).col
    IF Labels(c).win = ZOrder(1) THEN drawtext LabelTexts(c), wx% + Labels(c).x, wy% + Labels(c).y, Labels(c).col, 0, 0
    IF TextBoxes(c).win = ZOrder(1) THEN drawtextbox wx% + TextBoxes(c).x, wy% + TextBoxes(c).y, TextBoxes(c).length, TextBoxes(c).col, TextBoxTexts(c)
  NEXT c
  END IF
NEXT w
MouseShow
END SUB

SUB RemoveValidIf (num%)
validif(num%) = 0
END SUB

FUNCTION Return.Variable.Value$ (variable$)
varval% = 0
DO
  varval% = varval% + 1
  IF UCASE$(variable$) = UCASE$(var(varval%)) THEN Return.Variable.Value$ = varstr(varval%)
LOOP UNTIL varval% = 200
END FUNCTION

FUNCTION WindowInterfere% (id%)
WindowInterfere% = 0
x% = Windows(ZOrder(id%)).x: y% = Windows(ZOrder(id%)).y
x2% = Windows(ZOrder(id%)).x2: y2% = Windows(ZOrder(id%)).y2
wid% = x2% - x%
hei% = y2% - y%

FOR z = 20 TO 1 STEP -1
inwin% = 0
  IF MouseLimit(x%, y%, wid%, hei%) = -1 THEN
    inwin% = -1
    zx% = Windows(ZOrder(z)).x: zy% = Windows(ZOrder(z)).y
    zx2% = Windows(ZOrder(z)).x2: zy2% = Windows(ZOrder(z)).y2
    zwid% = zx2% - zx%
    zhei% = zy2% - zy%
    IF MouseLimit(zx%, zy%, zwid%, zhei%) = -1 THEN
      IF z > GetZOrder%(id%) THEN WindowInterfere% = -1
    END IF
  END IF
NEXT z
END FUNCTION

